#include <time.h>
#include <iostream>
#include "../cppfl/http.h"
#include "../cppfl/stringex.h"
using namespace std;
using namespace Net;

#if defined(_MSC_VER)
#include <regex>
using namespace tr1;
#else
#include <boost/regex.hpp>
using namespace boost;
#endif

int main(int argc,char* argv[])
{
	// mixi login
	map<string,string> params;
	int interval = 30;

	if (argc<2) {
		cerr << "usage: " << argv[0] << " mail [passwd] [interval]" << endl;
		return 1;
	}
	if (argc>=3)
		params["password"] = argv[2];
	if (argc>=4)
		interval = atoi(argv[3]);

	params["email"] = argv[1];
	params["next_url"] = "/home.pl";
	
	if (params["password"]=="") {
		cout << "# Ppasswd: " << flush;
		cin >> params["password"];
	}

	HttpClient hc;
	hc.load("http://mixi.jp/login.pl",params);

	string cookie;
	for (int i=0;i<hc.headers["Set-Cookie"].size();i++) {
		cookie += split(string(" "),hc.headers["Set-Cookie"][i])[0];
	}
	if (cookie.size()<=0) {
		cout << "Error: login failed." << endl;
		return 1;
	}
	cout << "# mixi ssid: " << cookie << endl;

	smatch match;
	if (!regex_search(cookie, match, regex("BF_SESSION=(\\d+)_"))) {
		cout << "Error: mixi id." << endl;
		return 1;
	}
	string mixi_id = match[1].str();

	// mixi appli
	hc.clear();
	hc.req_header["Cookie"] =  cookie;
	hc.load("http://mixi.jp/run_appli.pl?id=6598");

	if (!regex_search(hc.body, match, regex("<iframe src=\"(http://[^\"]+)\" id=\"app_content_"))) {
		cout << "Error: iframe." << endl;
		return 1;
	}

	string url = string( match[1].first, match[1].second ) ;

	if (!regex_search(url, match, regex("http://([^/]+)/[^#]+#st=([^&]+)"))) {
		cout << "Error: url parse error." << endl;
		return 1;
	}

	string host = string( match[1].first, match[1].second ) ;
	string st = urldecode(string( match[2].first, match[2].second ) );
	//cout << host << endl;
	//cout << st << endl;

	// opensocial
	params.clear();
	params["url"]="http://m1.3gokushi.jp/user/mixi_if.php";
	params["httpMethod"]="POST";
	params["postData"]=string("mixi_id=")+mixi_id;
	params["authz"]="signed";
	params["st"]=st;
	params["signOwner"]="true";
	params["signViewer"]="true";
	params["gadget"]="http://m1.3gokushi.jp/canvas.php";

	hc.clear();
	hc.method = HttpClient::GET;
	hc.req_header["X-Mixi-Platform-IO"] = "1";
	hc.load( "http://" + host + "/gadgets/makeRequest" ,params);

	string data = replace(hc.body,"\\\"","");
	//cout << data << endl;
	if (!regex_search(data, match, regex("p:(\\d+),.*ts:(\\d+),.*cd:(\\w+),"))) {
		cout << "Error" << endl;
		return 1;
	}

	// 3gokushi login
	string param_p =  match[1].str();
	string param_ts =  match[2].str();
	string param_cd =  match[3].str();

	hc.clear();
	hc.req_header["User-Agent"] =  "Mozilla/5.0 (test) Firefox/3";
	hc.load( "http://m9.3gokushi.jp/login.php?ts="+param_ts+"&cd="+param_cd+"&p="+param_p+"&ch=m");

	string ssid;
	if(hc.headers["Set-Cookie"].size()) {
		ssid += split(" ",hc.headers["Set-Cookie"][hc.headers["Set-Cookie"].size()-1])[0];
	}
	if (ssid.size()<=0) {
		cout << "Error: 3gokushi.jp login failed." << endl;
		return 1;
	}
	cout << "# 3gokushi ssid: " << ssid << endl;
	cout << "# interval =  " << interval << endl;

	for (;;) {
		hc.clear();
		hc.req_header["Cookie"] =  ssid;
		hc.req_header["User-Agent"] =  "Mozilla/5.0 (test) Firefox/3";
		hc.load("http://m9.3gokushi.jp/village.php");
		
		cout << time(NULL) << "\t";
		char *names[] = {"wood","stone","iron","rice"};
		for (int i=0; i<sizeof(names)/sizeof(char*); i++) {
			if (regex_search(hc.body, match, regex(string("<span class=\"normal\" id=\"")+names[i]+"\">([^<]+)</span>"))) {
				cout << match[1].str() << "\t";
			} else {
				cout << "?\t";
			}
		}
		if (regex_search(hc.body, match, regex("<img[^>]+ico_human.gif[^>]+> (\\d+) <span"))) {
			cout << match[1].str() << "\t";
		} else {
			cout << "?\t";
		}

		cout << endl;
		if (interval<0) break;
		Sleep(interval*1000);
	}

	return 0;
}
